#include "isxdl.iss"

[Setup]
; NOTE: The value of AppId uniquely identifies this application.
; Do not use the same AppId value in installers for other applications.
; (To generate a new GUID, click Tools | Generate GUID inside the IDE.)
AppName={cm:MyAppName}
AppVerName={cm:MyAppVerName}
AppPublisher={cm:MyAppPublisher}
AppPublisherURL={cm:MyURL}
AppSupportURL={cm:MyURL}
AppUpdatesURL={cm:MyURL}
DefaultDirName={code:DirToInstall}
UsePreviousAppDir=no
DirExistsWarning=yes
Uninstallable=no
;DefaultGroupName={cm:MyAppName}
DisableProgramGroupPage=yes
AllowNoIcons=yes
Compression=lzma
SolidCompression=yes
ShowLanguageDialog=no

[Languages]
;Name: en; MessagesFile: compiler:Default.isl; LicenseFile: \\bx\Projects\Projects\Assembler\setup\license_en.txt
;Name: ru; MessagesFile: compiler:Languages\Russian.isl; LicenseFile: \\bx\Projects\Projects\Assembler\setup\license_ru.txt
Name: en; MessagesFile: compiler:Default.isl
Name: ru; MessagesFile: compiler:Languages\Russian.isl

[_ISTool]
EnableISX=true

[Files]
Source: .setup_files\dbconn_utf.php; DestDir: {code:App}\bitrix\php_interface; Check: ISRunUTF; DestName: dbconn.php
Source: .setup_files\dbconn.php; DestDir: {code:App}\bitrix\php_interface; Check: ISRunNoUTF; DestName: dbconn.php
Source: .setup_files\bsm_demo_utf\*; DestDir: {code:App}\..\mysql\data\bsm_demo; Check: ISRunUTF; Flags: recursesubdirs createallsubdirs
Source: .setup_files\bsm_demo\*; DestDir: {code:App}\..\mysql\data\bsm_demo; Check: ISRunNoUTF; Flags: recursesubdirs createallsubdirs
Source: .setup_files\.htaccess; DestDir: {code:App}\; Check: ISRunNoUTF; DestName: .htaccess; Flags: overwritereadonly
Source: .setup_files\.htaccess_utf; DestDir: {code:App}\; Check: ISRunUTF; DestName: .htaccess; Flags: overwritereadonly

; [Icons]
; Name: {group}\1-:  ; Filename: {app}\MyProg.exe

[Run]
Filename: {code:App}\..\BitrixEnv.exe; Description: {cm:Run}; Flags: nowait postinstall runminimized runascurrentuser; WorkingDir: {app}; Check: ISRun
Filename: cacls; Parameters: """{app}"" /E /T /C /G ""USERS"":F"; Flags: runhidden; StatusMsg:       ; MinVersion: 0,6.0.6000


[Messages]
ru.WelcomeLabel1=   %n"[name]"
ru.WelcomeLabel2=  "[name/ver]"   .%n%n      ,  .

[CustomMessages]
ru.MyAppName=1-:  
ru.MyAppVerName=1-:   7.0
ru.MyAppPublisher=1-
ru.MyURL=http://www.1c-bitrix.ru/?r1=install&r2=win
ru.Run= "1-:  "
ru.BitrixEnvUrl=http://www.1c-bitrix.ru/download/bitrixenv/bitrix_env.exe
ru.InstallEnv= "1-:  "   ": -"
ru.EnvErr= ": -"      .
ru.bitrix_Caption= ": -"
ru.bitrix_Description=": -"    "1-:  "    
ru.bitrix_Label1_Caption0=  ": -"        "1-:  " : Apache, PHP, MySQL, Zend Optimizer, EAccelerator.
ru.bitrix_Label1_Caption1=  ": -"        "1-:  " : Apache, PHP, MySQL, Zend Optimizer, EAccelerator.
ru.bitrix_CheckBox1_Caption0=   ": -" (12Mb) ()
ru.bitrix_CheckBox1_Caption1= ": -" ()
ru.WarnNoEnv=!    "1-:  "    -,   , PHP.%n       ?
ru.ChooseOtherFolder=      "1C-:  ".   , ,      .
ru.bitrix_Label2_Caption0=        ,         UTF-8.
ru.bitrix_CheckBox2_Caption0=    UTF-8

en.MyAppName=Bitrix Site Manager
en.MyAppVerName=Bitrix Site Manager 7.0
en.MyAppPublisher=Bitrix
en.MyURL=http://www.bitrixsoft.com/?r1=install&r2=win
en.Run=Run Bitrix Site Manager
en.BitrixEnvUrl=http://www.bitrixsoft.com/download/bitrixenv/bitrix_env_en.exe
en.InstallEnv=Install Bitrix Site Manager in Bitrix Environment
en.EnvErr=Installation of Bitrix Environment has been interrupted or completed with errors.
en.bitrix_Caption=Installation of Bitrix Environment
en.bitrix_Description=Bitrix Environment allows to run Bitrix Site Manager without having to install support software
en.bitrix_Label1_Caption0=To deploy Bitrix Site Manager you can download and install Bitrix Environment which contains all the required software: Apache, PHP, MySQL, Zend Optimizer, EAccelerator.
en.bitrix_Label1_Caption1=To deploy Bitrix Site Manager you can install Bitrix Environment which contains all the required software: Apache, PHP, MySQL, Zend Optimizer, EAccelerator.
en.bitrix_CheckBox1_Caption0=Download and install Bitrix Environment (12Mb) (recommended)
en.bitrix_CheckBox1_Caption1=Install Bitrix Environment (recommended)
en.WarnNoEnv=Attention! Bitrix Site Manager requires web server, database server and PHP to run.%nAre you sure you want to install these applications manually?
en.ChooseOtherFolder=The destination folder already has an installation of Bitrix Site Manager. Please delete the contents of this folder or choose another to continue.
en.bitrix_Label2_Caption0=If you intend to use multiple languages at your site, install Bitrix Site Manager in UTF-8 mode.
en.bitrix_CheckBox2_Caption0=Install in UTF-8 mode

[Code]
var
  Label1: TLabel;
  CheckBox1: TCheckBox;
  Label2: TLabel;
  CheckBox2: TCheckBox;
  Download: Boolean;
  Run: Boolean;
  RunName: String;
  Panel1: TPanel;


function ISRun():Boolean;
begin
	if Download then
		Result := True
	else
		Result := False;
end;

function ISRunNoUTF():Boolean;
begin
	if ISRun() then
	begin
		if CheckBox2.Checked then
			Result := False
		else
			Result := True;
	end
	else
		Result := False;
end;

function ISRunUTF():Boolean;
begin
	if ISRun() then
	begin
		if CheckBox2.Checked then
			Result := True
		else
			Result := False;
	end
	else
		Result := False;
end;


{ bitrix_Activate }

procedure bitrix_Activate(Page: TWizardPage);
begin
  // enter code here...
end;

{ bitrix_ShouldSkipPage }

function bitrix_ShouldSkipPage(Page: TWizardPage): Boolean;
begin
  Result := False;
end;

{ bitrix_BackButtonClick }

function bitrix_BackButtonClick(Page: TWizardPage): Boolean;
begin
  Result := True;
end;

{ bitrix_NextkButtonClick }

function bitrix_NextButtonClick(Page: TWizardPage): Boolean;
begin
//  Page := wpLicense;
  if CheckBox1.checked then
  begin
    Download := true;
    isxdl_AddFile(ExpandConstant('{cm:BitrixEnvUrl}'), ExpandConstant('{tmp}\bitrixenv.exe'));
  end
  else
    Download := False;

  Result := True;
end;

{ bitrix_CancelButtonClick }

procedure bitrix_CancelButtonClick(Page: TWizardPage; var Cancel, Confirm: Boolean);
begin
  // enter code here...
end;


function ShouldSkipPage(PageID: Integer): Boolean;
begin
  { Skip pages that shouldn't be shown }
  if (PageID = wpSelectDir) or (PageID = wpSelectProgramGroup) then
  begin
    if CheckBox1.checked then
      Result := True
    else
      Result := False
  end
  else
    Result := False;
end;

procedure OnCheckboxClick(Sender: TObject);
begin
	if not CheckBox1.Checked then
	begin
		if MsgBox(ExpandConstant('{cm:WarnNoEnv}'), mbInformation, MB_YESNO) <> IDYES then
		begin
			CheckBox1.Checked := true;
		end;
	end;
	Label2.Enabled := CheckBox1.Checked;
	CheckBox2.Enabled := CheckBox1.Checked;
end;


{ bitrix_CreatePage }

function bitrix_CreatePage(PreviousPageId: Integer): Integer;
var
  Page: TWizardPage;
begin
  Page := CreateCustomPage(
    PreviousPageId,
    ExpandConstant('{cm:bitrix_Caption}'),
    ExpandConstant('{cm:bitrix_Description}')
  );

{ Label1 }
  Label1 := TLabel.Create(Page);
  with Label1 do
  begin
    Parent := Page.Surface;
    if Run then
		Caption := ExpandConstant('{cm:bitrix_Label1_Caption1}')
	else
		Caption := ExpandConstant('{cm:bitrix_Label1_Caption0}');

    Left := ScaleX(0);
    Top := ScaleY(10);
    Width := ScaleX(412);
    Height := ScaleY(45);
    AutoSize := False;
    WordWrap := True;
  end;

  { CheckBox1 }
  CheckBox1 := TCheckBox.Create(Page);
  with CheckBox1 do
  begin
    Parent := Page.Surface;
    if Run then
		Caption := ExpandConstant('{cm:bitrix_CheckBox1_Caption1}')
	else
		Caption := ExpandConstant('{cm:bitrix_CheckBox1_Caption0}');

    Left := ScaleX(10);
    Top := ScaleY(70);
    Width := ScaleX(400);
    Height := ScaleY(17);
    TabOrder := 0;
    Checked:= True;
    OnClick := @OnCheckboxClick;
  end;

  { Label2 }
  Label2 := TLabel.Create(Page);
  with Label2 do
  begin
    Parent := Page.Surface;
	Caption := ExpandConstant('{cm:bitrix_Label2_Caption0}')

    Left := ScaleX(50);
    Top := ScaleY(100);
    Width := ScaleX(300);
    Height := ScaleY(45);
    AutoSize := False;
    WordWrap := True;
  end;

  { CheckBox1 }
  CheckBox2 := TCheckBox.Create(Page);
  with CheckBox2 do
  begin
    Parent := Page.Surface;
	Caption := ExpandConstant('{cm:bitrix_CheckBox2_Caption0}')

    Left := ScaleX(60);
    Top := ScaleY(150);
    Width := ScaleX(400);
    Height := ScaleY(17);
    TabOrder := 0;
    Checked:= True;
  end;


  with Page do
  begin
    OnActivate := @bitrix_Activate;
    OnShouldSkipPage := @bitrix_ShouldSkipPage;
    OnBackButtonClick := @bitrix_BackButtonClick;
    OnNextButtonClick := @bitrix_NextButtonClick;
    OnCancelButtonClick := @bitrix_CancelButtonClick;
  end;

  Result := Page.ID;
end;

{ bitrix_InitializeWizard }

procedure InitializeWizard();
begin
	Run := False;
	if FileExists(GetCurrentDir() + '\bitrix_env.exe') then
	begin
		RunName := GetCurrentDir() + '\bitrix_env.exe';
		Run := True;
	end
	else if FileExists(GetCurrentDir() + '\bitrix\bitrix_env.exe') then
	begin
		RunName := GetCurrentDir() + '\bitrix\bitrix_env.exe';
		Run := True;
	end;
  bitrix_CreatePage(wpLicense);
end;

function NextButtonClick(CurPage: Integer): Boolean;
var
  hWnd: Integer;
  ResultCode: Integer;
begin
  Result := true;

  if CurPage = wpReady then begin
    if Run and CheckBox1.checked then
    begin
	   	Exec(RunName, 'norun', '', SW_SHOW, ewWaitUntilTerminated, ResultCode);
		  if ResultCode <> 0 then
      begin
          MsgBox(ExpandConstant('{cm:EnvErr}'), mbInformation, MB_OK);
          Result := false;
      end;
    end
	  else if Download then
    begin
      hWnd := StrToInt(ExpandConstant('{wizardhwnd}'));
      if (isxdl_DownloadFiles(hWnd) = 0) then
        Result := false
      else
      begin
        Exec(ExpandConstant('{tmp}\bitrixenv.exe'), 'norun', '', SW_SHOW, ewWaitUntilTerminated, ResultCode);
        if ResultCode <> 0 then
        begin
          MsgBox(ExpandConstant('{cm:EnvErr}'), mbInformation, MB_OK);
          Result := false;
        end;
      end;
    end;
  end
  else
  begin
	if CurPage = wpSelectDir then
	begin
		if FileExists(ExpandConstant('{app}') + '\bitrix\index.php') then
		begin
			MsgBox(ExpandConstant('{cm:ChooseOtherFolder}'), mbInformation, MB_OK);
			Result := false;
		end;
	end;
  end;
end;

Procedure CurStepChanged(CurStep: TSetupStep);
var    IndexFile: String;

begin
  if CurStep = ssInstall then
  begin
    if Download then
    begin
      //Abort;
    end;
  end;
end;

function DirToInstall(Param: String): String;
var path: String;
begin
  if RegQueryStringValue(HKLM, 'Software\Bitrix\BitrixEnv', 'Path', path) then
    Result := path + '\www'
  else
    Result := ExpandConstant('{pf}') + '\1C-Bitrix';

//MsgBox('DirToInstall.'+Result, mbInformation, MB_OK);

end;

function App(Param: String): String;
var path: String;
begin
  if Download and RegQueryStringValue(HKLM, 'Software\Bitrix\BitrixEnv', 'Path', path) then
    Result := path + '\www'
  else
    Result := ExpandConstant('{app}');
end;


function UpdateReadyMemo(Space, NewLine, MemoUserInfoInfo, MemoDirInfo, MemoTypeInfo, MemoComponentsInfo, MemoGroupInfo, MemoTasksInfo: String): String;
var
	cTemp: String;
begin
  if CheckBox1.checked then
  begin
    cTemp := ExpandConstant('{cm:InstallEnv}');
	if CheckBox2.checked then
	begin
		cTemp := cTemp + NewLine + ExpandConstant('{cm:bitrix_CheckBox2_Caption0}');
	end;
  end
  else
  begin
  	cTemp := cTemp + MemoDirInfo + NewLine + NewLine;
  end;

  Result := cTemp;
end;
